unit UFichierTexte;

interface

uses
  UTableau,//pour pouvoir manipuler la structure TTableau
  Sysutils;

//I-O pour un tableau
procedure sauver(const t: TTableau; nomFichier: string);
procedure charger(nomFichier: string; var t: TTableau);

//I-O pour 2 tableaux
procedure sauver_twin(const t1,t2: TTableau; nomFichier: string);
procedure charger_twin(nomFichier: string; var t1,t2: TTableau);

implementation

procedure sauver(const t: TTableau; nomFichier: string);
var f: TextFile;
    ligne: string;
    i: integer;
begin
 AssignFile(f,nomFichier);
 Rewrite(f);
 for i:= 0 to length(t)-1 do
  begin
   ligne:= FLOATTOSTR(t[i]);//pour transformer le numrique en chane
   writeln(f,ligne);//ou, directement => writeln(f,FLOATTOSTR(t[i]));
  end;
 CloseFile(f);
end;

procedure charger(nomFichier: string; var t: TTableau);
var f: TextFile;
    ligne: string;
    valeur: double;
    numLigne: integer;
begin
 AssignFile(f,nomFichier);
 Reset(f);
 numLigne:= 0;//numro de ligne
 //tant que pas fin de fichier
 while (eof(f) = false) do
  begin
   Readln(f,ligne); //lire la ligne dans le fichier
   setLength(t,numLigne+1); //Modifier dynamiquement la taille du tableau (+1 case)
   valeur:= STRTOFLOAT(ligne); //transtyper
   t[numLigne]:= valeur; //affecter  la bonne case, attention 0 based
   numLigne:= numLigne+1; //incrmenter le numro de ligne
  end;
 CloseFile(f);
end;

procedure sauver_twin(const t1,t2: TTableau; nomFichier: string);
var f: TextFile;
    ligne: string;
    i: integer;
begin
 AssignFile(f,nomFichier);
 Rewrite(f);
 for i:= 0 to length(t1)-1 do
  begin
   ligne:= FLOATTOSTR(t1[i])+';'+FloatToStr(t2[i]);
   writeln(f,ligne);
  end;
 CloseFile(f);
end;

procedure charger_twin(nomFichier: string; var t1,t2: TTableau);
var f: TextFile;
    ligne: string;
    v1,v2: double;
    numLigne,p: integer;
begin
 AssignFile(f,nomFichier);
 Reset(f);
 numLigne:= 0;
 while (eof(f) = false) do
  begin
   Readln(f,ligne);
   //Modifier dynamiquement la taille du tableau
   setLength(t1,numLigne+1);
   setLength(t2,numLigne+1);
   //rcuprer la position du ';'
   p:= pos(';',ligne);
   //copier et convertir ce qu'il y a avant le ';'
   v1:= StrToFloat(copy(ligne,1,p-1));
   t1[numLigne]:= v1; //affecter  la bonne case
   //copier et convertir ce qu'il y a aprs le ';'
   v2:= StrToFloat(copy(ligne,p+1,length(ligne)-p));
   t2[numLigne]:= v2;
   //incrmenter le numro de ligne
   numLigne:= numLigne + 1;
  end;
 CloseFile(f);
end;

end.
